<?php
/***********************************************************************
 *              Tribes-3.de
 *              Admin Section
 * Page:        admin_article.php
 * Begin:       30.6.2004, cloned from admin_news.php
 * Updated:     Version 2.0, 29.10.2004
 **********************************************************************/
 
    define('IN_GOLEM',true);
    $root_path = "./../";
    include $root_path."admin/common.php";
    
    if(!isset($_SESSION['rights']['articles']) || $_SESSION['rights']['articles'] == 1)
    {
        message_die("You don't have the expected rights to view this section.","admin_overview.php?show=main");
    }

    if(isset($_GET['action']))
    {
        if($_GET['action'] == "write") // write page!
        {
            if($_SESSION['rights']['articles'] == 3)
            {
                $query = "SELECT article_id, article_headline
                          FROM ".TABLE_ARTICLES." ORDER BY article_date DESC";
                $result = $sql->query($query) or die($sql->error);
            }
            else
            {
                $query = "SELECT article_id, article_headline
                          FROM ".TABLE_ARTICLES."
                          WHERE user_id = '".$_SESSION['user']['id']."'
                          ORDER BY article_date DESC";
                $result = $sql->query($query) or die($sql->error);
            }
                
            if(isset($result))
            {
                $articles = array();
                while($row = $sql->fetch($result))
                {
                    $articles[] = $row;
                }
            }
            
            if(count($articles) == 0)
            {
                message_die("You can't create an article page if there is no article to post in. Move on to create an article first!","admin_article.php?action=add");
            }
            else
            {
                if(isset($_GET['article']))
                {
                    $template->assign('article_id',$_GET['article']);
                }
            
                $template->assign('articles',$articles);
                $template->display('articles/write.tpl');
            }
        }
        else if($_GET['action'] == "comments")
        {
            if(isset($_GET['delete']))
            {
                if($_SESSION['rights']['articles'] == 3)
                {
                    reset($_GET['delete']);
                    while(current($_GET['delete']))
                    {
                        if(current($_GET['delete']) == "on")
                        {
                            $query = "DELETE FROM ".TABLE_COMMENTS."
                                      WHERE comment_id = '".key($_GET['delete'])."'";
                            $result = $sql->query($query) or die($sql->error);
                            
                            admin_log_create($_SESSION['user']['id'],LOG_ARTICLES,"Comment (ID: ".key($_GET['delete']).") deleted.");
                            
                            echo "Comment (ID: ".key($_GET['delete']).") deleted.<br />";
                        }
                        
                        next($_GET['delete']);
                    }
                }
                else
                {
                    message_die("Ce n'est pas possible!","admin_article.php?action=comments");
                }
            }
        
            $query = "SELECT u.user_id, u.username, c.comment_date,
                             c.comment_id, c.comment_section, c.comment_text
                      FROM ".TABLE_FORUM_USERS." u, ".TABLE_COMMENTS." c
                      WHERE u.user_id = c.user_id
                      ORDER BY c.comment_date DESC LIMIT 0,30";
            $result = $sql->query($query) or die($sql->error);
            
            if(isset($result))
            {
                $comments = array();
                $i = 1;
                while($row = $sql->fetch($result))
                {
                    $row['num'] = $i++;
                    $row['comment_text'] = $html->process($row['comment_text']);
                    $comments[] = $row;
                }
            }
            
            $template->assign('comments',$comments);
            $template->display('articles/comments.tpl');
        }
        else if($_GET['action'] == "add")
        {
            $query = "SELECT category_id, category_name
                      FROM   ".TABLE_ARTICLES_CATEGORY."
                      ORDER BY category_name ASC";
            $result = $sql->query($query) or die($sql->error);
            
            if(isset($result))
            {
                $categories = array();
                while($row = $sql->fetch($result))
                {
                    $categories[] = $row;
                }
            }
            
            $query = "SELECT teaser_id, teaser_headline, teaser_path
                      FROM ".TABLE_ARTICLES_TEASER."
                      ORDER BY teaser_date DESC";
            $result = $sql->query($query) or die($sql->error);
            
            if(isset($result))
            {
                $teasers = array();
                while($row = $sql->fetch($result))
                {
                    $teasers[] = $row;
                }
            }
            
            $query = "SELECT c.category_id, c.category_name
                      FROM  ".TABLE_NEWS_CATEGORY." c
                      WHERE  c.category_type = 0
                      ORDER BY c.category_name ASC";
            $result = $sql->query($query) or die($sql->error);
            
            if(isset($result))
            {
                $games = array();
                while($row = $sql->fetch($result))
                {
                    $row['category_name'] = $html->strip($row['category_name']);
                
                    $games[] = $row;
                }
            }

            // hinder ppl to post articles without having categories yet!
            if(count($categories) == 0)
            {
                message_die("You can't create an article if there is no category to post in. Move on to create an article category!","admin_article.php?action=category");
            }
            else
            {
                $template->assign('games',$games);
                $template->assign('teasers',$teasers);        
                $template->assign('categories',$categories);
                $template->display('articles/add.tpl');
            }
        }
        else if($_GET['action'] == "edit")
        {
            $sort = false;
            
            if($_SESSION['rights']['articles'] == 3)
            {
                $query = "SELECT a.article_id, a.article_headline,
                                 p.page_id, p.page_headline
                          FROM   ".TABLE_ARTICLES." a
                          LEFT JOIN ".TABLE_ARTICLES_PAGES." p
                          ON  p.article_id = a.article_id
                          ORDER BY a.article_date DESC";
            }
            else
            {
                $query = "SELECT a.article_id, a.article_headline,
                                 p.page_id, p.page_headline
                          FROM   ".TABLE_ARTICLES." a
                          LEFT JOIN ".TABLE_ARTICLES_PAGES." p
                          ON p.article_id = a.article_id
                          WHERE  a.user_id = '".$_SESSION['user']['id']."'
                          ORDER BY a.article_date DESC";
            }
            $result = $sql->query($query) or die($sql->error);
            
            if(isset($result))
            {
                $articles = array();
                $temp = array();
                while($row = $sql->fetch($result))
                {
                    $article_id = $row['article_id'];
                
                    // fix0r teh array!
                    if($row['page_id'] != '')
                    {
                        $temp['page_id'] = $row['page_id'];
                        $temp['page_headline'] = $row['page_headline'];
                        $row['pages'][] = $temp;
                    }
                        
                    unset($row['page_id']);
                    unset($row['page_headline']);
                
                    if(isset($articles[$article_id]))
                    {
                        $articles[$article_id]['pages'][] = $temp;
                    }
                    else
                    {
                        $articles[$article_id] = $row;
                    }
                }
                
                $template->assign('articles',$articles);
            }  
            
            $template->display('articles/list_edit.tpl');
        }
        else if(isset($_GET['action']) && $_GET['action'] == "delete")
        {
            // nur administratoren duerfen artikel loeschen!
            if($_SESSION['rights']['users'] == 3)
            {
                $query = "SELECT a.article_id, a.article_headline, a.article_desc
                          FROM   ".TABLE_ARTICLES." a
                          ORDER BY a.article_date DESC";
                $result = $sql->query($query) or die($sql->error);
                
                if(isset($result))
                {
                    $articles = array();
                    while($row = $sql->fetch($result))
                    {
                        $articles[] = $row;
                    }
                    
                    $template->assign('articles',$articles);
                }
            }
            
            $template->display('articles/list_delete.tpl');
        }
        else if($_GET['action'] == "visible")
        {
            if(isset($_GET['id']))
            {
                $query = "UPDATE ".TABLE_ARTICLES." SET article_visible = '1'
                          WHERE article_id = '".$_GET['id']."'";
                $result = $sql->query($query) or die($sql->error);
            }
        
            if($_SESSION['rights']['users'] == 3)
            {
                $query = "SELECT a.article_id, a.article_headline, a.article_date, u.user_name
                          FROM ".TABLE_ARTICLES." a, ".TABLE_USER." u
                          WHERE a.user_id = u.user_id AND
                                a.article_visible = '0'
                          ORDER BY a.article_date DESC";
            }
            else
            {
                $query = "SELECT a.article_id, a.article_headline, a.article_date, u.user_name
                          FROM ".TABLE_ARTICLES." a, ".TABLE_USER." u
                          WHERE a.user_id = u.user_id AND
                                a.article_visible = '0' AND
                                a.user_id = '".$_SESSION['user']['id']."'
                          ORDER BY a.article_date DESC";
            }
            $result = $sql->query($query) or die($sql->error);
            
            if(isset($result))
            {
                $articles = array();
                while($row = $sql->fetch($result))
                {
                    $articles[] = $row;
                }
            }
            
            $template->assign('articles',$articles);
            $template->display('articles/visibilty.tpl');
        }
        else if($_GET['action'] == "category")
        {
        
        }
    }
    else if(isset($_POST['action']))
    {
        if($_POST['action'] == "preview")
        {
            if($_SESSION['rights']['articles'] == 3)
            {
                $query = "SELECT article_id, article_headline
                          FROM ".TABLE_ARTICLES." ORDER BY article_date DESC";
                $result = $sql->query($query) or die($sql->error);
            }
            else
            {
                $query = "SELECT article_id, article_headline
                          FROM ".TABLE_ARTICLES."
                          WHERE user_id = '".$_SESSION['user']['id']."'
                          ORDER BY article_date DESC";
                $result = $sql->query($query) or die($sql->error);
            }
                
            if(isset($result))
            {
                $articles = array();
                while($row = $sql->fetch($result))
                {
                    $articles[] = $row;
                }
            }
            
            // preview message parts
            $message = $html->process($_POST['message']);
        
            $template->assign('articles',$articles);
            $template->assign('article_id',$_POST['article_id']);
            $template->assign('headline',stripslashes($_POST['headline']));
            $template->assign('message',stripslashes($_POST['message']));
            $template->assign('sort',$_POST['sort']);
            $template->assign('preview_msg',stripslashes($message));
            $template->assign('session_name',$_SESSION['user']['name']);
            $template->assign('time',time());
            $template->display('articles/preview.tpl');
        }
        else if($_POST['action'] == "add")
        {
            $headline = addslashes($_POST['headline']);
            $descr = addslashes($_POST['desc']);
            
            if(isset($_POST['teaser_id']) && $_POST['teaser_id'] != 0)
            {
                $teaser_id = $_POST['teaser_id'];
            }
            else
            {
                if(isset($_FILES['teaser']['tmp_name']) && $_FILES['teaser']['tmp_name'] != '')
                {
                    $imgsize = getimagesize($_FILES['teaser']['tmp_name']);
                    
                    if($imgsize[0] == 100 && $imgsize[1] == 68)
                    {
                        $img_time = substr(time(),4,6);
                        if(move_uploaded_file($_FILES['teaser']['tmp_name'],$config['imagepath']."teaser/teaser_".$img_time.".jpg"))
                        {
                            $query = "INSERT INTO ".TABLE_ARTICLES_TEASER." SET teaser_path = '".$config['basedir']."shared/pics/upload/teaser/teaser_".$img_time.".jpg',
                                                                         teaser_headline = '".$headline."',
                                                                         user_id = '".$_SESSION['user']['id']."',
                                                                         teaser_date = '".time()."'";
                            $result = $sql->query($query) or die($sql->error);
                            
                            if(isset($result))
                            {
                                $teaser_id = $sql->get_insert_id();
                            }
                        }
                        else
                        {
                            $teaser_id = 1;
                            echo "Using Standard Teaser-Image: Error occured, while uploading!";
                        }
                    }
                    else
                    {
                        $teaser_id = 1;
                        echo "Using Standard Teaser-Image: Error occured, image not 150x90 huge!";
                    }
                }
                else
                {
                    $teaser_id = 1;
                    echo "No Teaser-Image uploaded: Using Standard!<br />";
                }
            }
            
            $query = "INSERT INTO ".TABLE_ARTICLES." SET article_headline = '".$headline."',
                                              game_id = '".$_POST['game_id']."',
                                              article_desc = '".$descr."',
                                              article_date = '".time()."',
                                              category_id = '".$_POST['category_id']."',
                                              user_id = '".$_SESSION['user']['id']."',
                                              article_visible = '0',
                                              article_index = '".$_POST['index']."',
                                              teaser_id = '".$teaser_id."',
                                              article_special = '".$_POST['special']."'";
            $result = $sql->query($query) or die($sql->error);
            
            if(isset($result))
            {
                $article_id = $sql->get_insert_id();
                admin_log_create($_SESSION['user']['id'],LOG_ARTICLES,"Article Container (".$headline.") created.",$article_id);
                message_die("Successfully created  an article container","admin_overview.php?show=main");
            }
        }
        else if($_POST['action'] == "write")
        {
            $message = addslashes($_POST['message']);
            $headline = addslashes($_POST['headline']);
            $date = time(); 
            
            $query = "INSERT INTO ".TABLE_ARTICLES_PAGES." SET page_headline = '".$headline."',
                                              page_body = '".$message."',
                                              page_lastedit = '".$date."',
                                              article_id = '".$_POST['article_id']."',
                                              user_id = '".$_SESSION['user']['id']."',
                                              page_sort = '".$_POST['sort']."'";
            $result = $sql->query($query) or die($sql->error);
            
            if(isset($result))
            {
                admin_log_create($_SESSION['user']['id'],LOG_ARTICLES,"Page has been attached to article (ID: ".$_POST['article_id'].")",$_POST['article_id']);
                message_die("Successfully attached a new page to the chosen article!","admin_article.php?action=write&amp;article=".$_POST['article_id']);
            }
        }
        else if($_POST['action'] == "editcontainer")
        {
            $headline = addslashes($_POST['headline']);
            $descr = addslashes($_POST['descr']);
            
            $query = "UPDATE ".TABLE_ARTICLES." SET article_headline = '".$headline."',
                                             game_id = '".$_POST['game_id']."',
                                             article_desc = '".$descr."',
                                             article_special = '".$_POST['special']."',
                                             article_index = '".$_POST['index']."',
                                             category_id = '".$_POST['category_id']."',
                                             teaser_id = '".$_POST['teaser_id']."'
                                         WHERE article_id = '".$_POST['newsid']."'";
            $result = $sql->query($query) or die($sql->error);
            
            if(isset($result))
            {
                admin_log_create($_SESSION['user']['id'],LOG_ARTICLES,"Article Container (ID: ".$_POST['newsid'].") has been edited.",$_POST['newsid']);
                message_die("You've successfully edited an article container!","admin_article.php?action=edit");
            } 
        }
        else if($_POST['action'] == "editpage")
        {
            $headline = addslashes($_POST['headline']);
            $message = addslashes($_POST['message']);
            
            $query = "UPDATE ".TABLE_ARTICLES_PAGES." SET page_headline = '".$headline."',
                                                   page_body = '".$message."',
                                                   article_id = '".$_POST['article_id']."',
                                                   page_lastedit = '".time()."'
                                               WHERE page_id = '".$_POST['pageid']."'";
            $result = $sql->query($query) or die($sql->error);
            
            if(isset($result))
            {
                admin_log_create($_SESSION['user']['id'],LOG_ARTICLES,"Article Page (Article-ID: ".$_POST['article_id']." Page-ID: ".$_POST['pageid'].") has been edited.",$_POST['article_id']);
                message_die("You edited an article page successfully!","admin_article.php?action=edit");
            }
        }
        else if(isset($_POST['news_id']))
        {
            if($_POST['action'] == "edit")
            {
                // edit container!
                $news_id = $_POST['news_id'];
                if($_POST['page_id'][$news_id] == 0)
                {
                    if(isset($_POST['do']) && $_POST['do'] == "sort")
                    {
                        $query = "UPDATE ".TABLE_ARTICLES_PAGES." p SET p.page_sort = '".$_POST['sort'][$_POST['page']]."'
                                                           WHERE p.page_id = '".$_POST['page']."'";
                        $result = $sql->query($query) or die($sql->error);
                    }
                
                    $query = "SELECT category_id, category_name
                              FROM   ".TABLE_ARTICLES_CATEGORY."
                              ORDER BY category_name ASC";
                    $result = $sql->query($query) or die($sql->error);
                    
                    if(isset($result))
                    {
                        $categories = array();
                        while($row = $sql->fetch($result))
                        {
                            $categories[] = $row;
                        }
                        
                        $template->assign('categories',$categories);
                    }
    
                    $query = "SELECT teaser_id, teaser_headline, teaser_path
                              FROM ".TABLE_ARTICLES_TEASER."
                              ORDER BY teaser_date DESC";
                    $result = $sql->query($query) or die($sql->error);
                    
                    if(isset($result))
                    {
                        $teasers = array();
                        while($row = $sql->fetch($result))
                        {
                            $teasers[] = $row;
                        }
                        
                        $template->assign('teasers',$teasers);
                    }    
                    
                    $query = "SELECT c.category_id, c.category_name
                              FROM   ".TABLE_NEWS_CATEGORY." c
                              WHERE  c.category_type = 0
                              ORDER BY c.category_name ASC";
                    $result = $sql->query($query) or die($sql->error);
                    
                    if(isset($result))
                    {
                        $games = array();
                        while($row = $sql->fetch($result))
                        {
                            $row['category_name'] = $html->strip($row['category_name']);
                        
                            $games[] = $row;
                        }
                        
                        $template->assign('games',$games);
                    }
                    
                    $query = "SELECT p.page_id, p.page_headline, p.page_sort,
                                     p.page_lastedit, u.user_name
                              FROM ".TABLE_ARTICLES_PAGES." p, ".TABLE_USER." u
                              WHERE u.user_id = p.user_id AND
                                    p.article_id = '".$_POST['news_id']."'
                              ORDER BY p.page_sort ASC";
                    $result = $sql->query($query) or die($sql->error);
                    
                    if(isset($result))
                    {
                        $pages = array();
                        while($row = $sql->fetch($result))
                        {
                            $pages[] = $row;
                        }
                        
                        $template->assign('pages',$pages);
                    }
                    
                    $query = "SELECT a.article_id,a.article_headline, a.article_desc, a.article_visible,
                                     a.article_date, a.article_special, a.article_index,
                                     c.category_id, c.category_name,
                                     u.user_id, u.user_name, t.teaser_id,
                                     t.teaser_path, t.teaser_date, a.game_id
                              FROM   ".TABLE_ARTICLES." a, ".TABLE_ARTICLES_CATEGORY." c, ".TABLE_USER." u,
                                     ".TABLE_ARTICLES_TEASER." t
                              WHERE  a.category_id = c.category_id AND
                                     a.user_id = u.user_id AND
                                     a.teaser_id = t.teaser_id AND
                                     a.article_id = '".$_POST['news_id']."'";
                    $result = $sql->query($query) or die($sql->error);
                    
                    if(isset($result))
                    {
                        $article = $sql->fetch($result);
                        $article['article_desc'] = stripslashes($article['article_desc']);
                        
                        $template->assign('article_id',$_POST['news_id']);
                        $template->assign('article',$article);
                        $template->assign('preview_descr',$html->process($article['article_desc']));
                        
                        $template->display('articles/edit_container.tpl');
                    }
                }
                // edit page!
                else
                {
                    if($_SESSION['rights']['articles'] == 3)
                    {
                        $query = "SELECT article_id, article_headline
                                  FROM ".TABLE_ARTICLES." ORDER BY article_date DESC";
                        $result = $sql->query($query) or die($sql->error);
                    }
                    else
                    {
                        $query = "SELECT article_id, article_headline
                                  FROM ".TABLE_ARTICLES."
                                  WHERE user_id = '".$_SESSION['user']['id']."'
                                  ORDER BY article_date DESC";
                        $result = $sql->query($query) or die($sql->error);
                    }
                        
                    if(isset($result))
                    {
                        $articles = array();
                        while($row = $sql->fetch($result))
                        {
                            $articles[] = $row;
                        }
                    }                
                
                    $query = "SELECT p.page_id, p.page_headline, p.page_body, p.page_lastedit,
                                     p.page_sort, u.user_name, a.article_headline,
                                     p.article_id
                              FROM   ".TABLE_ARTICLES." a, ".TABLE_ARTICLES_PAGES." p, ".TABLE_USER." u
                              WHERE  p.article_id = a.article_id AND
                                     p.user_id = u.user_id AND
                                     p.page_id = '".$_POST['page_id'][$news_id]."'";
                    $result = $sql->query($query) or die($sql->error);
                    
                    if(isset($result))
                    {
                        $article = $sql->fetch($result);
                        
                        $article['page_headline'] = stripslashes($article['page_headline']);
                        $article['page_body'] = stripslashes($article['page_body']);
                        
                        $template->assign('articles',$articles);
                        $template->assign('article',$article);
                        $template->assign('preview_msg',$html->process($article['page_body']));
                        $template->display('articles/editpage.tpl');
                    }
                }
            }
            else if($_POST['action'] == "delete")
            {
                $query = "DELETE FROM ".TABLE_ARTICLES." WHERE article_id = '".$_POST['news_id']."'";
                $result = $sql->query($query) or die($sql->error);
                
                if(isset($result))
                {
                    $query = "DELETE FROM ".TABLE_ARTICLES_PAGES." WHERE article_id = '".$_POST['news_id']."'";
                    $result = $sql->query($query) or die($sql->error);
                                    
                    admin_log_create($_SESSION['user']['id'],LOG_ARTICLES,"Article deleted.",$_POST['news_id']);
                    message_die("Deleted the selected item!","admin_article.php?action=delete");
                }
            }
        }
    }
    
    include $root_path."include/pagetail.php";    
?>