<?php
///////////////////////////////////////////////////////////////////////////////
//
// IRC client module for PHP IRC clients
//
// This file contains all the configuration options for the main module,
// phpIRC.php3.
//
// Please take care to adjust everything correctly here.
//
// This software and all associated files are released
// under the GNU Public License (GPL), see gpl.txt for details.
//
// Copyright (c) 1999, 2000 by Till Gerken, till@phpwebdev.com
//
///////////////////////////////////////////////////////////////////////////////

$irc_default_nick = "Julia[T3DE]";		// default nickname to choose
$irc_default_realname = "Julia";	// default real name
$irc_default_identd = "Julia";		// default identd, should match server identd
$irc_valid_identd = 1;				// 0 - IDENTD is faked
									// 1 - IDENTD is true
$irc_host = "www.tribes-3.de";	// name of our own host - needed for connecting
									// MUST be valid! DON'T USE IP IF IT RESOLVES!

$irc_socket_timeout = 20;			// number of seconds to use until connection
									// attempts time out
									// NOTE: use 0 to disable socket timeouts!
									// (this is needed for older PHP versions)

$irc_layer_version = "phpIRC v1.2 - The PHP IRC layer (c) Till Gerken, till@phpwebdev.com - Running on ".phpversion();

define("IRC_MAX_CHANNELS", 8);		// maximal number of channels that can be joined
define("IRC_MAX_CALLBACKS", 32);	// maximal number of callbacks for anything
define("IRC_MAX_TIMERS", 2);		// maximal number of timers

// callback definition
class irc_callback
{
	var $code;						// code to act upon
	var $function;					// function to call
}

// timer definition
class irc_timer
{
    var $last_call;					// timestamp of last call
    var $interval;					// interval to call at
    var $function;					// function to call
}

// channel class definition
class irc_channel
{
    var $name;						// channel name
    var $topic;						// channel topic
    var $mode;						// channel mode
    var $nick_list;					// channel nick list
}

// ok, now define a whole bunch of constants
define("IRCEREG_HOSTNAME", "([a-zA-Z0-9\.-]+)");
define("IRCEREG_SERVER_MESSAGE_NR", "([0-9]{3})");
define("IRCEREG_NICK", "([a-zA-Z0-9\\\^\{\}\[\]\|_`-]+)");
define("IRCEREG_CHANNEL", "([a-zA-Z0-9#_\\\^\{\}\|_-]+)");
define("IRCEREG_COMMAND", "([a-zA-Z]+)");
define("IRCEREG_SPLITUSERHOST", "(.+)!(.+)@(.+)");
define("IRCEREG_WHOISUSER", "(.+) (.+) (.+) \* :(.*)");

define("IRC_NOBREAK", 1000);
define("IRCCB_ONIDLE", 1001);
define("IRCCB_ONKILL", 1002);
define("IRCCB_ONNOTICE", 1100);
define("IRCCB_ONPRIVMSG", 1101);
define("IRCCB_ONJOIN", 1102);
define("IRCCB_ONPART", 1103);
define("IRCCB_ONQUIT", 1104);
define("IRCCB_ONKICK", 1105);
define("IRCCB_ONCHANNELMSG", 1106);
define("IRCCB_ONOP", 1200);
define("IRCCB_ONDEOP", 1201);
define("IRCCB_ONVOICE", 1202);
define("IRCCB_ONDEVOICE", 1203);
define("IRCCB_ONBAN", 1204);
define("IRCCB_ONUNBAN", 1205);
define("IRCCB_ONMODECHANGE", 1300);
define("IRCCB_ONNICKCHANGE", 1400);
define("IRCCB_ONTOPICCHANGE", 1500);
define("IRCCB_ONCTCPPING", 1600);
define("IRCCB_ONACTION", 1700);

define("IRCERR_NOSUCHNICK", 401);
define("IRCERR_NICKNAMEINUSE", 433);
define("IRCERR_INVITEONLYCHAN", 473);

define("IRCRPL_ISON", 303);

define("IRCRPL_AWAY", 301);
define("IRCRPL_WHOISUSER", 311);
define("IRCRPL_WHOISSERVER", 312);
define("IRCRPL_WHOISIRCOP", 313);
define("IRCRPL_WHOISIDLE", 317);
define("IRCRPL_ENDOFWHOIS", 318);
define("IRCRPL_WHOISCHANNELS", 319);

define("IRCRPL_TOPIC", 332);
define("IRCRPL_NAMREPLY", 353);
define("IRCRPL_ENDOFNAMES", 366);
define("IRCRPL_ENDOFMOTD", 376);

?>