<?php
	/** LICENSE **
	*
	* Tribes Vengeance Server Query is free software; you can redistribute it
	* and/or modify it under the terms of the GNU General Public License as
	* published by the Free Software Foundation; either version 2 of the License,
	* or (at your option) any later version.
	* 
	* This program is free software; you can redistribute it and/or modify
	* it under the terms of the GNU General Public License as published by
	* the Free Software Foundation; either version 2 of the License, or
	* (at your option) any later version.
	* 
	* You should have received a copy of the GNU General Public License
	* along with this program; if not, write to the Free Software 
	* Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307,
	* USA.
	* 
	* Tribes Vengeance Server Query class, Copyright (C) 2004 Littlex & tribes-3.de
	* Tribes Vengeance Server Query class comes with ABSOLUTELY NO WARRANTY; This is free software,
	* and you are welcome to redistribute it under certain conditions.
	* 
	* For more details read GNU_LICENSE.txt
	*
	***/


	/** HEADER **
	*
	*
	* /!\ BEFORE YOU READ THIS CHECK THE readme.txt /!\
	* /!\ BEFORE YOU READ THIS CHECK THE readme.txt /!\
	*
	* 
	* @name Tribes Vengeance Server Query
	*
	* @author   Littlex (t3de team member) * littlex@tribes-3.de * http://www.tribes-3.de
	* @version  1.4, 10.10.2004
	* 
	* @since 1	
	*           Programmed all Basics, its to much to write it down here :)
	*
	* @since 1.1
	*           Fixed two bugs:
	*           1. The Script bugged arround when there was only one player on a server.
	*           2. If there is a non-alphanumeric char, T:V is returning an utf8 encoded string.
	*              Now i am decoding utf8 signs so there shouldnt be a problem now with weird signs :)
	*           -thanks to Cowboy for reporting those bugs
	*
	* @since 1.2
	*           Fixed one bug:
	*           1. .'s < "DOTS :)" where ignored in strings because of a programming error :|
	*           -thanks to Toaster for reporting that bug
	* 
	* @since 1.3
	*           The Script was made compatible with the T:V demo.
	*           Two new information available. (is dedicated server and gamemode [Public, Competition i guess])
	*           Changed the output array a bit.
	*
	* @since 1.4
	*           Retail 1.0 and 1.01 are supported.
	*           Changed the Arraysplit code.
	*           Fixed one bug with unknown parameters.
	*           Two new information available. (variant and minimum version)
	* 
	* Use the set() and get() functions of this class to change or read any propertys! Anything else is lame 
	* and wrong oop usage.
	* 
	* @example
	*           How to query a server:
	*           --------------------------------------------------------------------------------------------------
	*           // Create a class instance
	*           $query = &new tvquery();
	*           // Query the server
	*           $info  = $query->getserverinfo('193.23.224.169', 7777);
	*           // Show the output array
	* 			print_r($info);
	* 
	*           You will get an array which is providing all server information you could need :)
	* 
	*           If an error occurs $info['error'] will be TRUE and $info will contain an error ID,
	*           the associated errormessage and error TYPE (warning or error).
	*           Note: Warnings DONT halt the script and if a warning occurs $info['error'] still will be FALSE!
	* 
	*           Array
	*           (
	*               [error] => 1
	*               [id] => 200
	*               [type] => error
	*               [message] => No server running
	*           )
	* 
	*           Scroll down to the property _errorMessages to get an overview of existing errors.
	*           --------------------------------------------------------------------------------------------------
	* 
	* 
	*           How to read a property (you dont need this to use this script!):
	*           --------------------------------------------------------------------------------------------------
	*           You only have rights to access the _formating, _serverversion, _timeout and _errorMessages propertys
	* 
	*           get(WHICH PROPERTY, KEY); this will return the selected key from the property array
	*           or
	*           get(WHICH PROPERTY); this will return the whole property array
	* 
	*           $query = &new tvquery();
	*           echo $query->get('_serverversion', '55256');
	*           => This would provide "Beta 04"
	* 
	*           $query = &new tvquery();
	*           echo $query->get('_errorMessages');
	*           => This would return the whole _errorMessages Array
	* 
	*           --------------------------------------------------------------------------------------------------
	* 
	*           How to change a property (you dont need this to use this script!):
	*           --------------------------------------------------------------------------------------------------
	*           You only have rights to access the _formating, _serverversion, _timeout and _errorMessages propertys
	*           You can NOT add new entries to the _formating and _errorMessages array, but you can change them.
	* 
	*           set(WHICH PROPERTY, NEW VALUE, KEY);
	*           or
	*           set(WHICH PROPERTY, NEW ARRAY); this will replace the whole property with a new Array, but the
	*           array you are providing HAS to contain all keys like the one you want to replace contains.
	* 
	*           This would change the Connection timed out message to "The damn connection timed out"
	*           $query = &new tvquery();
	*           $query->set('_errorMessages', 'The damn connection timed out', 101);
	*
	*           This would change the timeout value to 15
	*           $query = &new tvquery();
	*           $query->set('_timeout', 15);
	*           --------------------------------------------------------------------------------------------------
	* 
	*           About the _formating property (you dont need this to use this script!):
	*           --------------------------------------------------------------------------------------------------
	*           You have the ability to change the layout of the output Array which is returned by getserverinfo,
	*           this is done thru the property "_formating" and the usage of set(). _formating contains the whole
	*           structure of the output array!
	*
	*           Every key of the _formating array represents a server- or a function generated information, so dont
	*           change them! :) Scroll down to the _formating property for a detailed description of every key.
	*           I repeat: DONT CHANGE THE KEYS OF _formating!
	* 
	*           The values of _formating have to be arrays (lets call these arrays category's), even if there is only
	*           one entry in the category array! Every entry in one of the category arrays of _formating represents a
	*           new sub array in the final output array. I guess this is a bit confusing :)
	*
	*           Here is an example:
	*           You have "'mapname' => array('one')" that means there would be a new sub array created in the output array
	*           which is reachable thru the key "one". That means $info['one'] would return you in this case the mapname.
	*
	*           Here is a more advanced example:
	*           "'mapname' => array('one','two','three')" The mapname would be available thru $info['one']['two']['three'];
	*
	*           I hope its more clear now.
	*
	*           Now to the very advanced stuff :)
	*			You can use the keywords: "this:_formatingKEY" and "create:newemptyarray" as category.
	*
	*			The keyword "this:a_formatingKEY" allows you to access information which where written allready into
	*           the final output array. If the information is not available in that moment the script will return "unknown".
	*           (i guess i will change this later :)
	*           As example, normaly this:gametype should return you the currently running gametype which will be used then
	*           as category. Lets say the gametype is CTF and we have this category array:
	*           "'mapname' => array('one','this:gametype','three')". So the mapname would be available in this case thru
	*           $info['one']['CTF']['three'];
	*			
	*			"create:newemptyarray" is pretty simple this will just create an new array entry like $array[].
	*           --------------------------------------------------------------------------------------------------
	*           
	*           - Sorry for the bad english :)
	*           - EOF header
	***/
	class tvquery
	{
		
		// Array stuff :)
		/**
		 * Formating stuff
		 * This one allows you to change the output array after your needs!
		 * You can create as many subcategories (values) as you want
		 * 
		 * Function Internal means that this variable is created by this class not by the Server
		 * 
		 * Please use the set()/get() function of this Class to modify/read this Array
		 * REMEMBER: you can modify the VALUES after your needs, but DONT change the KEYS!
		 * 
		 **/	
		var $_formating = array (
			// Mapname
			'mapname'           => array('server', 'info', 'map'),
			// Serveradmin Name
			'adminname'         => array('server', 'admin', 'name'),
			// Serveradmin E-Mail
			'adminemail'        => array('server', 'admin', 'mail'),
			// Serverwide Average Ping
			'avrgping'          => array('server', 'average', 'ping'), // Function Internal
			// Serverwide Average Score
			'avrgscore'         => array('server', 'average', 'score'), // Function Internal
			// Gamename (dunno this one, maybe later for mods?)
			'gamename'          => array('server', 'info', 'game', 'name'),
			// Gamemode (dunno this one, maybe Public play or Competion mode?)
			'gamemode'          => array('server', 'info', 'game', 'mode'),
			// Dedicated Server
			'dedicated'         => array('server', 'info', 'dedicated'),
			// Server Name
			'hostname'          => array('server', 'info', 'name'),
			// On what port the Server is Running
			'hostport'          => array('server', 'connectivity', 'port'),
			// What port the User provided (Some serveradmins are maybe routing the Ports)
			'providedport'      => array('server', 'connectivity', 'provided_port'), // Function Internal
			// Server IP
			'hostip'            => array('server', 'connectivity', 'ip'), // Function Internal
			// Gametype (CTF and such stuff)
			'gametype'          => array('server', 'info', 'game', 'type'),
			// zero clue about this one
			'gamevariant'       => array('server', 'info', 'game', 'variant'),
			// Which gameversion the Server is running
			'gamever'           => array('server', 'info', 'version', 'clean'),
			// Translated Gameversion (eg. Beta 05)
			'translatedver'     => array('server', 'info', 'version', 'translated'), // Function Internal
			// Is the gameversion supported by this script (True/False)
			'supportedver'      => array('server', 'info', 'version', 'supported'), // Function Internal
			// I guess this is the Version the gameclient needs to have to be able to play on the server
			'minver'           => array('server', 'info', 'version', 'minimum'),
			// Serverpassworded TRUE/FALSE
			'password'          => array('server', 'info', 'passworded'),
			// Since Beta 05 (dunno, seems  to be stats tracking)
			'trackingstats'     => array('server', 'info', 'statstracking'),
			// Subcategory for players Information (we need this to set this false if the server is empty)
			'players'           => array('players', 'teams'), // Function Internal
			// The players of team one will be saved in this subcategory
			'playersteamone'    => array('players', 'teams', 'team_1', 'create:newemptyarray'), // Function Internal
			// the players of team two will be saved in this subcategory
			'playersteamtwo'    => array('players', 'teams', 'team_2', 'create:newemptyarray'), // Function Internal
			// Observers will be saved in this subcategory
			'playersobserver'   => array('players', 'teams', 'observers'), // Function Internal
			// Number of currently playing people
			'numplayers'        => array('players', 'current'),
			// Max number of Players
			'maxplayers'        => array('players', 'max'),
			// Name of team one
			'teamone'           => array('teams', 'team_1', 'name'),
			// Name of team two
			'teamtwo'           => array('teams', 'team_2', 'name'),
			// Scores of team one
			'teamonescore'      => array('teams', 'team_1', 'score'),
			// Scores of team two
			'teamtwoscore'      => array('teams', 'team_2', 'score'),
			// Count of players in team one
			'teamoneplayers'    => array('teams', 'team_1', 'count'), // Function Internal
			// Count of players in team two
			'teamtwoplayers'    => array('teams', 'team_2', 'count'), // Function Internal
			// Average ping of team one
			'teamoneavrping'    => array('teams', 'team_1', 'average', 'ping'), // Function Internal
			// Average ping of team two
			'teamtwoavrping'    => array('teams', 'team_2', 'average', 'ping'), // Function Internal
			// Average score of team one
			'teamoneavrscore'   => array('teams', 'team_1', 'average', 'score'), // Function Internal
			// Average score of team two
			'teamtwoavrscore'   => array('teams', 'team_2', 'average', 'score'), // Function Internal
			// Count of observers
			'observers'         => array('teams', 'observers', 'count'), // Function Internal
			// Average ping of observers
			'observersavrping'  => array('teams', 'observers', 'average', 'ping'), // Function Internal
			// Average score of observers
			'observersavrscore' => array('teams', 'observers', 'average', 'score'), // Function Internal
			// Maybe there are some Servervariables which this Script is unable to catch, so we use this container
			'catch_remaining'   => array('misc')
		);
	
		/**
		 * Server versions
		 * 
		 * Please use the set()/get() function of this Class to modify/read this Array
		 * REMEMBER: you can modify the VALUES after your needs, but DONT change the KEYS!
		 * 
		 **/
		var $_serverversion = array (
			'55256' => 'Beta 04',
			'59023' => 'Beta 05',
			'59407' => 'Beta 059',
			'62740' => 'Demo',
			'61735' => 'Retail 1.0',
			'63446' => 'Retail 1.1'
		);
		
		/**
		 * Error Messages
		 * 
		 * Please use the set()/get() function of this Class to modify/read this Array
		 * REMEMBER: you can modify the VALUES after your needs, but DONT change the KEYS!
		 * 
		 **/
		var $_errorMessages = array (
			// Unable to set a timeout limit, this could lead to looooonnnnng loading times if the server is down
			'90'  => 'Unable to set timout',
			// Unable to set blockmode, blockmode is better but it should work without it
			'91'  => 'Unable to set blockmode',
			// WTF, we cant connect to the server! :)
			'100' => 'Cant connect to server',
			// We where able to connect but timed out, slow server or something like that? :o
			'101' => 'Connection timed out',
			// No gameserver running on that machine
			'200' => 'No server running'
		);
		
		// timout
		var $_timeout = 5;
		
		// Dont touch this
		var $server_IP;
		var $server_PORT;
		var $serverInfo;
		var $_error = array ('error' => FALSE);
		/**
		 * The Statup function :)
		 * 
		 * @access public
		 * @return array 
		 **/
		function getserverinfo($ip, $port = 7777)
		{
			$ip = gethostbyname($ip);
			
			$this->server_IP   = $ip;
			$this->server_PORT = $port;
			
			$this->serverInfo = $playerInfo = $averageInfo = array();
			$this->_error = array ('error' => FALSE);
			
			$rawData = $this->_query($this->server_IP, $this->server_PORT);
			
			// Just do this when we are error free
			if (!$this->_error['error']) {
				$rawArray = $this->_rawArray($rawData);
				
				// Split the Array into Serverinfo and Playerinfo
				$splitedRawArray = $this->_splitArray($rawArray);
				
				// Server Information
				$this->serverInfo = $this->_parseServerInfo($splitedRawArray[0]);
				
				// Player Information	and our base for Average Stuff
				$mixedInfo = $this->_parsePlayerInfo($splitedRawArray[1],$this->serverInfo);
								
				// Average Stuff
				$averageInfo = $this->_parseAverageInfo($mixedInfo[1]);
				
				// Player Info
				$playerInfo = $mixedInfo[0];
			}
			
			return array_merge_recursive($this->serverInfo, $playerInfo, $averageInfo, $this->_error);
		}
		
		/**
		 * Allows the user to modify $_formating, $_serverversion and $_errorMessages a good way :o
		 * 
		 * @access public
		 * @return bool 
		 **/
		function set($whichArray, $value, $key = FALSE)
		{
			$return = FALSE;
			switch ($whichArray) {
				case '_formating':
					if ($key) {
						if (isset($this->_formating[$key])) {
							$this->_formating[$key] = $value;
							$return = TRUE;							
						}
					}
					else {
						$diff = array_diff(array_keys($this->_formating),array_keys($value));
						if (empty($diff)) {
							$this->_formating = $value;
							$return = TRUE;
						}
					}
					break;
				case '_errorMessages':
					if ($key) {
						if (isset($this->_errorMessages[$key])) {
							$this->_errorMessages[$key] = $value;
							$return = TRUE;							
						}
					}
					else {
						$diff = array_diff(array_keys($this->_errorMessages),array_keys($value));
						if (empty($diff)) {
							$this->_errorMessages = $value;
							$return = TRUE;
						}
					}
					break;
				case '_serverversion': 
					if ($key) {
						$this->_serverversion[$key] = $value;
						$return = TRUE;
					}
					else {
						$diff = array_diff(array_keys($this->_serverversion),array_keys($value));
						if (empty($diff)) {
							$this->_serverversion = $value;
							$return = TRUE;
						}
					}
					break;
				case '_timeout': 
					if (!is_array($value)) {
						$this->_timeout = $value;
						$return = TRUE;
					}
					break;
				default:
					$return = FALSE;
					break;
			} // switch

			return $return;
		}
		
		/**
		 * Allows the user to read $_formating, $_serverversion and $_errorMessages a good way :o
		 * 
		 * @access public
		 * @return string|array
		 **/
		function get($whichArray, $key = FALSE)
		{
			$return = FALSE;
			switch ($whichArray) {
				case '_formating':
					if ($key) {
						$return = $this->_formating[$key];
					}
					else {
						$return = $this->_formating;
					}
					break;
				case '_errorMessages':
					if ($key) {
						$return = $this->_errorMessages[$key];
					}
					else {
						$return = $this->_errorMessages;
					}
					break;
				case '_serverversion': 
					if ($key) {
						$return = $this->_serverversion[$key];
					}
					else {
						$return = $this->_serverversion;
					}
					break;
				case '_timeout': 
					$return = $this->_timeout;
					break;
				default:
					$return = array();
					break;
			} // switch

			return $return;
		}
		
		/**
		 * Connects to the server and retrieves the raw data if possible
		 *
		 * @access private
		 * @return void 
		 **/
		function _query($ip, $port)
		{
			// Into this array we will write our Serverinfo
			$returndata = array();
			
			// Connect to the server
			$socket = @fsockopen("udp://".$ip, $port+1, $errno, $errstr , 5);
			
			if ($socket) {
				// Set timeout and blocking
				if (!@socket_set_timeout($socket, $this->_timeout))
					$this->_errorHandling(90);
				if (!@socket_set_blocking($socket, true))
					$this->_errorHandling(91);
				// Pack the data
				$query = pack("CCxCCCxCCC*", 0xfe, 0xfd, 0xae, 0xca, 0x25, 0xff, 0xff, 0xff);
			
				// Write the data to the server
				$test = fputs($socket, $query);
			
				// We need to read at least one byte else socket_get_status and feof wont work properly
				// We dont need the 5 first bytes of the Serverinformation so we use theme here :)
				$rawdata = fread($socket, 5);
				
				// Retrieve Socketstatus
				$status = socket_get_status($socket);
				
				
				if ($status['unread_bytes'] > 0) {
					if ($status['timed_out'] != TRUE) {
						// now we know the Datalenght, lets read it all
						$rawdata = fread($socket, $status['unread_bytes']);
					}
					// Oh no we timed out :(
					else {
						$this->_errorHandling(101);
					}
				}
				else {
					$this->_errorHandling(200);
				}
				// Disconnect from server
				fclose($socket);
			}
			else {
				$this->_errorHandling(100);
			}
			
			return $rawdata;
		}
		
		/**
		 * Stores Every data entrie in a new array line
		 *
		 * @access private
		 * @return void 
		 **/
		function _rawArray($rawData)
		{
			// Cut the unnecessary Data
			$rawData = substr($rawData, 0, -3);
			
			// Datalenght		
			$len = strlen($rawData);

			$rawArray = array();
			$str = '';
	
			// Lets parse the HEX data into an Array
			for ($i=0; $i < $len; $i++) {
			
				$hex = $rawData{$i};
				
				// We want to skip Nullbytes and weird signs :)
				if ($hex != "\x00") {
					$str .= $hex;
				}
				
				// Nullbyte means new Array entry :)
				if ($hex == "\x00") {
					$rawArray[] = trim($str);
					$str = '';
				}
			}
			return $rawArray;
		}
		
		/**
		 * Splits the rawArray into server and player information
		 * 
		 * @access private
		 * @return array 
		 **/
		function _splitArray($rawArray) {
			$count = count($rawArray);
			
			$serverinfo = array();
			$playerinfo = array();
			
			$cut = array_search('trackingstats', $rawArray);
			
			for ($i=0; $i <= ($cut-3); $i++) {
				$serverinfo[] = $rawArray[$i];
			}
			for ($i=$cut; ; $i++) {
				if (empty($rawArray[$i])) {
					break;
				}
				$serverinfo[] = $rawArray[$i];
			}
			
			$cut = array_search('team_', $rawArray);
			$cut += 2;
			

			for ($i=$cut; $i < $count; $i++) {
				$playerinfo[] = $rawArray[$i];
			}
			return array($serverinfo,$playerinfo);
		}
	
		/**
		 * Apply a value to the specified array
		 * 
		 * @access private
		 * @return array 
		 **/
		function _applyValue($pattern, $value)
		{
			$returnMe = array();
			$reference = &$returnMe;
			$count = count($pattern);
			
			// Pattern ;p
			$preg_pattern_1 = '/^this\:(.*)$/Ui';
			$preg_pattern_2 = '/^create\:(.*)$/Ui';
			
			for ($i = 0; $i < $count; $i++) {
				$key = $pattern[$i];
				// Reads a value from the array which will be returned by this class	
				if (preg_match($preg_pattern_1, $pattern[$i], $matches)) {
					$key = $this->_readValue($this->_formating[$matches[1]],$this->serverInfo);
				}

				// You can create new Array elements with this, currently you can only created empty arrays
				if (preg_match($preg_pattern_2, $pattern[$i], $matches)) {
					switch ($matches[1]) {
						case 'newemptyarray': 
							$key = FALSE;
							break;
					} // switch
				}
				
				// Bad referencing :o
		   		$reference = &$reference[$key];
		   		
				// Apply the value
		   		if ($i == ($count-1)) {
		   			$reference = $value;
		   		}
			}
			return $returnMe;

		}
	
		/**
		 * Read a value from the specified array
		 * 
		 * @access private
		 * @return array 
		 **/
		function _readValue($pattern,$array) {
			
			$reference = &$array;
			
			foreach ($pattern as $value) {		
		   		$reference = &$reference[$value];
			}
			
			return $reference;
		}
	
		/**
		 * Parses serverinformation
		 *
		 * @access private
		 * @return array 
		 **/
		function _parseServerInfo($rawArray)
		{
			$count = count($rawArray);
		
			$serverInfo = array();
			$supportedver = array(
				'55256' => TRUE,
				'59023' => TRUE,
				'59407' => TRUE,
				'62740' => TRUE,
				'61735' => TRUE,
				'63446' => TRUE
			);
			
			// Lets format our Data
			for ($i=0; $i < $count; $i += 2)
			{
			
				if (isset($this->_formating[$rawArray[$i]])) {
					$pattern = $this->_formating[$rawArray[$i]];
				}
				// Uhm the server is returning an information which is no specified in our formating array
				else {
					$pattern = $this->_formating['catch_remaining'];
					$pattern = array_merge($pattern, array($rawArray[$i]));
				}
				
				// T:V is returning True/False as textstring, lets make it a bool
				if (strtolower($rawArray[($i+1)]) == 'false') {
					$value = FALSE;
				}
				elseif (strtolower($rawArray[($i+1)]) == 'true') {
					$value = TRUE;
				}
				else {
					$value = utf8_decode($rawArray[($i+1)]);
				}

				// Lets turn the Serverversion into a human understandable Text
				if ($rawArray[$i] == 'gamever') {
				 	$supported = FALSE;
					$translated = 'unknown';
					 if (isset($this->_serverversion[$value])) {
					 	$translated = $this->_serverversion[$value];
					 }
					 if (isset($supportedver[$value])) {
					 	$supported = TRUE;
					 }
					 
				 	$serverInfo = array_merge_recursive($serverInfo, $this->_applyValue($this->_formating['translatedver'], $translated), $this->_applyValue($this->_formating['supportedver'], $supported));
				}				
            	
				$serverInfo = array_merge_recursive($serverInfo, $this->_applyValue($pattern, $value));
				
			}
			
			// Add the serverIP and the user provided Port to the list
			$serverInfo = array_merge_recursive($serverInfo, $this->_applyValue($this->_formating['hostip'], $this->server_IP), $this->_applyValue($this->_formating['providedport'], $this->server_PORT));

			
			return $serverInfo; 
		}
				
		/**
		 * Parse Playerinfo and 
		 * 
		 * @access private
		 * @return array 
		 **/
		function _parsePlayerInfo($rawArray,$serverInfo)
		{
			
			$count = count($rawArray);
			
			$teamInfo = array();
			
			// Team1, Team2, Observer
			$information = array (
				'ping'    => 0,
				'score'   => 0,
				'perteam' => array (
					'count' => array(
						'team1'     => 0,
						'team2'     => 0,
						'observers' => 0
					),
					'ping'  => array(
						'team1'     => 0,
						'team2'     => 0,
						'observers' => 0
					),
					'score' => array(
						'team1'     => 0,
						'team2'     => 0,
						'observers' => 0
					)
				)
			);
			
			if ($count >= 4) {
				for ($i=0; $i < $count; $i += 4) {
					$team = empty($rawArray[($i+3)]) ? 'observer' : $rawArray[($i+3)];
					
					// we need this for average Information
					switch ($team) {
						case $this->_readValue($this->_formating['teamone'],$this->serverInfo): 
							$information['perteam']['count']['team1']++;
							$information['perteam']['ping']['team1']  += $rawArray[($i+1)];
							$information['perteam']['score']['team1'] += $rawArray[($i+2)];
							$applyto = 'playersteamone';
							break;
						case $this->_readValue($this->_formating['teamtwo'],$this->serverInfo):
							$information['perteam']['count']['team2']++;
							$information['perteam']['ping']['team2']  += $rawArray[($i+1)];
							$information['perteam']['score']['team2'] += $rawArray[($i+2)];
							$applyto = 'playersteamtwo';
							break;
						default:
							$information['perteam']['count']['observers']++;
							$information['perteam']['ping']['observers']  += $rawArray[($i+1)];
							$information['perteam']['score']['observers'] += $rawArray[($i+2)];
							$applyto = 'playersobserver';
							break;
					} // switch

					$playerinfo = array (
						'name'  => utf8_decode($rawArray[$i]),
						'ping'  => $rawArray[($i+1)],
						'score' => $rawArray[($i+2)]
					);
					
					$teamInfo = array_merge_recursive($teamInfo, $this->_applyValue($this->_formating[$applyto], $playerinfo));
					
					// We need this for global Average Ping and Score
					$information['ping']  += $rawArray[($i+1)];
					$information['score'] += $rawArray[($i+2)];
					
				}
			}
			// No players on the server :(
			else {
				$teamInfo = array_merge_recursive($teamInfo, $this->_applyValue($this->_formating['players'], FALSE));
			}

			return array($teamInfo, $information);			
		}
		
		/**
		 * "calculates" Average stuff, lots of array fuckage ;)
		 * 
		 * @access private
		 * @return array 
		 **/
		function _parseAverageInfo($teamInformation)
		{
			// Per Team playercount
			$averageInfo = array_merge_recursive($this->_applyValue($this->_formating['teamoneplayers'], $teamInformation['perteam']['count']['team1']), $this->_applyValue($this->_formating['teamtwoplayers'], $teamInformation['perteam']['count']['team2']), $this->_applyValue($this->_formating['observers'], $teamInformation['perteam']['count']['observers']));
			
			
			// Team 1 average Ping And Score
			
			switch (($count = $teamInformation['perteam']['count']['team1'])) {
				case 0: 
					$score = 0;
					$ping = 0;
					break;
				default:
					$score = round(($teamInformation['perteam']['score']['team1'] / $count));
					$ping = round(($teamInformation['perteam']['ping']['team1'] / $count));
					break;
			}
			
			$averageInfo = array_merge_recursive($averageInfo, $this->_applyValue($this->_formating['teamoneavrscore'], $score), $this->_applyValue($this->_formating['teamoneavrping'], $ping));
			
			// Team 2 average Ping And Score
			switch (($count = $teamInformation['perteam']['count']['team2'])) {
				case 0: 
					$score = 0;
					$ping = 0;
					break;
				default:
					$score = round(($teamInformation['perteam']['score']['team2'] / $count));
					$ping = round(($teamInformation['perteam']['ping']['team2'] / $count));
					break;
			}
			
			$averageInfo = array_merge_recursive($averageInfo, $this->_applyValue($this->_formating['teamtwoavrscore'], $score), $this->_applyValue($this->_formating['teamtwoavrping'], $ping));
			

			// Team Observer :) average Ping And Score
			switch (($count = $teamInformation['perteam']['count']['observers'])) {
				case 0: 
					$score = 0;
					$ping = 0;
					break;
				default:
					$score = round(($teamInformation['perteam']['score']['observers'] / $count));
					$ping = round(($teamInformation['perteam']['ping']['observers'] / $count));
					break;
			}
			
			$averageInfo = array_merge_recursive($averageInfo, $this->_applyValue($this->_formating['observersavrscore'], $score), $this->_applyValue($this->_formating['observersavrping'], $ping));

			// Serverwide average Ping and Score
			switch (($count = $teamInformation['perteam']['count']['team1'] + $teamInformation['perteam']['count']['team2'] + $teamInformation['perteam']['count']['observers'])) {
				case 0: 
					$score = 0;
					$ping = 0;
					break;
				default:
					$score = round(($teamInformation['score'] / $count));
					$ping = round(($teamInformation['ping'] / $count));
					break;
			}
			
			$averageInfo = array_merge_recursive($averageInfo, $this->_applyValue($this->_formating['avrgscore'], $score), $this->_applyValue($this->_formating['avrgping'], $ping));
			
			return $averageInfo;
		}
		
		/**
		 * Error catching function
		 * 
		 * @access private
		 **/
		function _errorHandling($id) {
			switch ($id) {
				// Unable to set timout
				case 90:
					$this->_error = array (
						'id'      => $id,
						'type'    => 'warning',
						'message' => $this->_errorMessages[$id]
					);
					break;
				// Unable to set blockmode
				case 91:
					$this->_error = array (
						'id'      => $id,
						'type'    => 'warning',
						'message' => $this->_errorMessages[$id]
					);
					break;
				// Cant connect to Server
				case 100:
					$this->_error = array (
						'error'   => TRUE,
						'id'      => $id,
						'type'    => 'error',
						'message' => $this->_errorMessages[$id]
					);
					break;
				// Connection timed out
				case 101:
					$this->_error = array (
						'error'   => TRUE,
						'id'      => $id,
						'type'    => 'error',
						'message' => $this->_errorMessages[$id]
					);
					break;
				// Probably no Server running or the Queryport is unreachable
				case 200:
					$this->_error = array (
						'error'   => TRUE,
						'id'      => $id,
						'type'    => 'error',
						'message' => $this->_errorMessages[$id]
					);
					break;
				default:
					$this->_error = array (
						'error'   => TRUE,
						'id'      => $id,
						'type'    => 'error'
					);
					break;				
			} // switch
		}
	}
?>