<?php
/************************************************************************
 *  Drunken:Golem Gaming Portal
 *
 *  file:           recordings.php
 *  begin:          24.8.2004
 *
 ************************************************************************/
 
    define('IN_GOLEM',true);
    $root_path = "./";
    include $root_path."common.php";
    
    // get last 5 game versions
    // they are display on top of the site, the selected one is "highlighted"
    
    $query = "SELECT version_id, version, name FROM ".TABLE_RECORDINGS_VERSIONS."
              ORDER BY version_id DESC LIMIT 0,5";
    $result = $sql->query($query) or die($sql->error);
    
    if(isset($result))
    {
        $versions = array();
        $i = 1;
        while($row = $sql->fetch($result))
        {
            if(isset($_GET['version_id']) && ($_GET['version_id'] == $row['version_id']))
            {
                $row['version'] = "<b>".$row['version']."</b>";
                $current_version_id = $row['version_id'];
            }
            else if(!isset($_GET['version_id']) && $i == 1)
            {
                $row['version'] = "<b>".$row['version']."</b>";
                $current_version_id = $row['version_id'];
            }
            
            $versions[] = $row;
            $i++;
        }
        
        $template->assign('versions',$versions);
        $template->assign('current_version_id',$current_version_id);
    }
    

    if(isset($_GET['id']))
    {
        $query = "SELECT recording_filepath FROM ".TABLE_RECORDINGS." WHERE recording_id = '".$_GET['id']."'";
        $result = $sql->query($query) or die($sql->error);
        
        if(isset($result))
        {
            $row = $sql->fetch($result);
            header("Location: ".$row['recording_filepath']);
        }
    }
    
    // main routine
    if(isset($_GET['section_id']))
    {
        if(isset($_GET['p']))
        {
            $page = $_GET['p'];
        }
        else
        {
            $page = 1;
        }
        
        $query = "SELECT count(r.recording_id) AS 'recordings'
                  FROM  ".TABLE_RECORDINGS." r
                  WHERE r.section_id = '".$_GET['section_id']."'
                  GROUP BY r.recording_id";
        $result = $sql->query($query) or die($sql->error);
        
        if(isset($result))
        {
            $row = $sql->fetch($result);
            $rec_count = $row['recordings'];
        }
        
        $pages_count = ceil($rec_count / 20);
        
        $pages = array();
        for($i = 1; $i <= $pages_count; $i++)
        {
            $pages[] = $i;
        }
        
        $template->assign('pages',$pages);
        $template->assign('pages_count',$pages_count);
        $template->assign('rec_count',$rec_count);
        $template->assign('current_page',$page);
        
        $entry = ($page > 0) ? (($page-1)*20) : 0;
        
        $query_mod = (isset($_GET['mod_id']) && $_GET['mod_id'] != -1) ? "r.mod_id = '".$_GET['mod_id']."' AND " : "";
        $query_position = (isset($_GET['position_id']) && $_GET['position_id'] != -1) ? "r.recording_prole = '".$_GET['position_id']."' AND " : "";
        
        if(isset($_GET['search']))
        {
            $search = str_replace(" ","%",$_GET['search']);
            $search = str_replace("?","%",$search);
        
            $query_search = "(r.recording_maps LIKE '%".$search."%' OR
                              r.team1_name LIKE '%".$search."%' OR
                              r.team2_name LIKE '%".$search."%' OR
                              r.recording_desc LIKE '%".$search."%' OR
                              r.recording_pov LIKE '%".$search."%') AND ";
                              
            $template->assign('search_string',$_GET['search']);
        }
        else
        {
            $query_search = NULL;
        }
    
        $query = "SELECT r.recording_upload, r.team1_name, r.team2_name,
                         r.team1_flag, r.team2_flag, r.recording_filesize,
                         r.recording_maps, r.recording_event, r.recording_pov,
                         r.recording_prole, m.mod_name, r.recording_id,
                         r.recording_desc
                  FROM   ".TABLE_RECORDINGS." r
                  LEFT JOIN ".TABLE_RECORDINGS_MODS." m
                  ON     r.mod_id = m.mod_id
                  WHERE  r.section_id = '".$_GET['section_id']."' AND
                         ".$query_mod."
                         ".$query_position."
                         ".$query_search."
                         r.version_id = '".$current_version_id."'
                  ORDER BY r.recording_upload DESC
                  LIMIT ".$entry.",20";
        $result = $sql->query($query) or die($sql->error);
        
        if(isset($result))
        {
            $recordings = array();
            while($row = $sql->fetch($result))
            {
                // use function from download section
                $row['recording_filesize'] = dl_calc_filesize($row['recording_filesize']);
                
                // player position?
                $row['recording_prole'] = rec_get_playerrole($row['recording_prole']);
                
                // html
                $row['recording_desc'] = $html->process($row['recording_desc']);
                $recordings[] = $row;
            }
            
            $query = "SELECT s.section_id, s.section_name, s.section_desc
                      FROM   ".TABLE_RECORDINGS_SECTIONS." s
                      WHERE  s.section_id = '".$_GET['section_id']."'";
            $result = $sql->query($query) or die($sql->error);
            
            if(isset($result))
            {
                $row = $sql->fetch($result);
                
                $section_id = $row['section_id'];
                $section_name = $row['section_name'];
                $section_desc = $row['section_desc'];
            }
            
            // get mods for filter options
            $query = "SELECT mod_id, mod_name FROM ".TABLE_RECORDINGS_MODS."
                      ORDER BY mod_name ASC";
            $result = $sql->query($query) or die($sql->error);
            
            if(isset($result))
            {
                $mods = array('0' => array('mod_id' => -1, 'mod_name' => 'Alle Mods'));
                while($row = $sql->fetch($result))
                {
                    $mods[] = $row;
                }
                
                if(isset($_GET['mod_id']))
                {
                    $current_mod_id = $_GET['mod_id'];
                }
                else
                {
                    $current_mod_id = -1;
                }
                
                $template->assign('current_mod_id',$current_mod_id);
            }
            
            // get player position filter options
            $positions = array('0' => array('key' => -1, 'name' => 'Alle Positionen'));
            $temp = array();
            reset($playerroles);
            while(current($playerroles))
            {
                $temp['key'] = key($playerroles);
                $temp['name'] = current($playerroles);
                $positions[] = $temp;
                unset($temp); 
                
                next($playerroles);
            }
            
            if(isset($_GET['position_id']))
            {
                $current_position_id = $_GET['position_id'];
            }
            else
            {
                $current_position_id = -1;
            }
            
            $template->assign('current_position_id',$current_position_id);
            $template->assign('positions',$positions);
            
            $template->assign('mods',$mods);
            $template->assign('section_id',$section_id);
            $template->assign('section_name',$section_name);
            $template->assign('section_desc',$section_desc);
            $template->assign('recordings',$recordings);
        }
        
        $template->display('recordings/viewsection.tpl');
    }
    else
    {
        $query = "SELECT s.section_id, s.section_name, s.section_desc,
                         count(r.recording_id) AS 'recordings',
                         r.team1_name, r.team2_name, r.team1_flag, r.team2_flag,
                         r.recording_upload, r.recording_id
                  FROM   ".TABLE_RECORDINGS_SECTIONS." s
                  LEFT JOIN ".TABLE_RECORDINGS." r
                  ON     s.section_id = r.section_id AND
                         r.version_id = '".$current_version_id."'
                  GROUP BY s.section_id
                  ORDER BY s.section_name ASC";
        $result = $sql->query($query) or die($sql->error);
        
        if(isset($result))
        {
            $sections = array();
            while($row = $sql->fetch($result))
            {
                $sections[] = $row;
            }
        }
        
        $template->assign('sections',$sections);
        
        $template->display('recordings/overview.tpl');
    }
    
    include $root_path."include/pagetail.php";
    
?>