<?php
/************************************************************************
 *  Drunken:Golem Gaming Portal
 *
 *  file:           search.php
 *  begin:          6.5.2004
 *
 ************************************************************************/

    define('IN_GOLEM',true);
    $root_path = "./";
    include $root_path."common.php";
 
    if(isset($_POST['search']))
    {
        $array = array();
        if($_POST['type'] == "news")
        {
            $search = str_replace(" ","%",$_POST['search']);
            $search = str_replace("?","%",$search);
            $array[] = (isset($_POST['headline']) && $_POST['headline'] == "on") ? "n.news_headline LIKE '%".$search."%'" : false;
            $array[] = (isset($_POST['body']) && $_POST['body'] == "on") ? "n.news_body LIKE '%".$search."%'" : false;
            $array = array_filter($array);
            
            if(count($array) > 1)
            {
                $search = implode($array," OR ");
            }
            else
            {
                $search = array_pop($array);
            }
        
            $query = "SELECT n.news_id, n.news_headline, n.news_comment,
                             n.news_desc, n.news_date, c.category_name,
                             u.user_name, (count(p.post_id)-1) AS 'comments'
                      FROM   ".TABLE_NEWS." n, ".TABLE_NEWS_CATEGORY." c, ".TABLE_USER." u
                      LEFT JOIN ".TABLE_FORUM_POSTS." p
                      ON n.news_comment = p.topic_id    
                      WHERE  (".$search.") AND
                             c.category_id = n.category_id AND
                             u.user_id = n.user_id
                      GROUP BY n.news_id
                      ORDER BY n.news_date DESC";
            $result = $sql->query($query) or die($sql->error);
            
            if(isset($result))
            {
                $search = array();
                while($row = $sql->fetch($result))
                {
                    $row['news_headline'] = $html->strip($row['news_headline']);
                    $row['news_desc'] = $html->process($row['news_desc']);
                    $search[] = $row;
                }
                
                $template->assign('search',$_POST['search']);
                $template->assign('numresults',$sql->numrows($result));
                $template->assign('news',$search);
                $template->display('search/results.tpl');
            }
        }
        else if($_POST['type'] == "articles")
        {
            $search = str_replace(" ","%",$_POST['search']);
            $search = str_replace("?","%",$search);
            $array[] = (isset($_POST['headline']) && $_POST['headline'] == "on") ? "a.article_headline LIKE '%".$search."%'" : false;
            $array[] = (isset($_POST['body']) && $_POST['body'] == "on") ? "a.article_body LIKE '%".$search."%'" : false;
            $array = array_filter($array);
        
            if(count($array) > 1)
            {
                $search = implode($array," OR ");
            }
            else
            {
                $search = array_pop($array);
            }
            
            $query = "SELECT a.article_id, a.article_headline,
                             a.article_desc, a.article_date, c.category_name,
                             u.user_name
                      FROM   ".TABLE_ARTICLES." a, ".TABLE_ARTICLES_CATEGORY." c, ".TABLE_USER." u
                      WHERE  (".$search.") AND
                             c.category_id = a.category_id AND
                             u.user_id = a.user_id
                      GROUP BY a.article_id
                      ORDER BY a.article_date DESC";
            $result = $sql->query($query) or die($sql->error);
            
            if(isset($result))
            {
                $search = array();
                while($row = $sql->fetch($result))
                {
                    $row['article_headline'] = $html->strip($row['article_headline']);
                    $row['article_desc'] = $html->process($row['article_desc']);
                    $search[] = $row;
                }
                
                $template->assign('search',$_POST['search']);
                $template->assign('numresults',$sql->numrows($result));
                $template->assign('articles',$search);
                $template->display('search/results.tpl');
            }
        }
    }
    else if(isset($_GET['month']) && isset($_GET['year']))
    {
        $query = "SELECT FROM_UNIXTIME(news_date,'%Y %m') AS 'date'
                  FROM   ".TABLE_NEWS."
                  GROUP BY FROM_UNIXTIME(news_date,'%Y %m')
                  ORDER BY news_date DESC";
        $result = $sql->query($query) or die($sql->error);
        
        if(isset($result))
        {
            while($row = $sql->fetch($result))
            {
                $date = explode(" ",$row['date']);
                $date['month'] = archive_num_month($date[1]);
                $archive[] = $date;
            }
            
            $template->assign('archives',$archive);
        }
    
        $start = mktime(0,0,1,$_GET['month'],1,$_GET['year']);
        $end = mktime(0,0,1,$_GET['month']+1,1,$_GET['year']);
        
        $query = "SELECT n.news_id, n.news_headline,
                         n.news_desc, n.news_date, c.category_img,
                         u.user_name
                  FROM   ".TABLE_NEWS." n, ".TABLE_NEWS_CATEGORY." c, ".TABLE_USER." u
                  WHERE  n.news_date >= '".$start."' AND
                         n.news_date <= '".$end."' AND
                         u.user_id = n.user_id AND
                         c.category_id = n.category_id
                  ORDER BY n.news_date DESC";
        $result = $sql->query($query) or die($sql->error);
        
        if(isset($result))
        {
            while($row = $sql->fetch($result))
            {
                $row['news_headline'] = $html->strip($row['news_headline']);
                $row['news_desc'] = $html->process($row['news_desc']);
                $articles[] = $row;
            }
        }
        
        $template->assign('articles',$articles);
        $template->display('search/archives.tpl');
    }
    else if(isset($_GET['action']) && $_GET['action'] == "archives")
    {
        $query = "SELECT FROM_UNIXTIME(news_date,'%Y %m') AS 'date'
                  FROM   ".TABLE_NEWS."
                  GROUP BY FROM_UNIXTIME(news_date,'%Y %m')
                  ORDER BY news_date DESC";
        $result = $sql->query($query) or die($sql->error);
        
        if(isset($result))
        {
            while($row = $sql->fetch($result))
            {
                $date = explode(" ",$row['date']);
                $date['month'] = archive_num_month($date[1]);
                $archive[] = $date;
            }
            
            $template->assign('archives',$archive);
        }
        
        $template->display('search/archives.tpl');
    }
    else
    {
        $query = "SELECT category_id, category_name
                  FROM   ".TABLE_NEWS_CATEGORY."
                  ORDER BY category_name ASC";
        $result = $sql->query($query) or die($sql->error);
        
        if(isset($result))
        {
            while($row = $sql->fetch($result))
            {
                $categories[] = $row;
            }
            
            $template->assign('categories',$categories);
        }
        
        $template->display('search/search.tpl');
    }
    
    include $root_path."include/pagetail.php";
?>